function chamBossname()
    local b = ffi.cast("char*", 0x52AB6C)
    b[0] = 0x43     b[1] = 0x55 
    b[2] = 0x53     b[3] = 0x54 
    b[4] = 0x4F     b[5] = 0x4D 
    b[6] = 0x5F     b[7] = 0x42 
    b[8] = 0x4F     b[9] = 0x53 
    b[10] = 0x53    b[11] = 0x4E 
    b[12] = 0x41    b[13] = 0x4D 
    b[14] = 0x45
end

function chamBossnameDefault()
    local b = ffi.cast("char*", 0x52AB6C)
    b[0] = 0x4C     b[1] = 0x45 
    b[2] = 0x56     b[3] = 0x45 
    b[4] = 0x4C     b[5] = 0x5F 
    b[6] = 0x42     b[7] = 0x4F 
    b[8] = 0x53     b[9] = 0x53 
    b[10] = 0x4E    b[11] = 0x41 
    b[12] = 0x4D    b[13] = 0x45 
    b[14] = 0
end

function chamDefeatVoice()
    local b = ffi.cast("char*", 0x52AB44)
    b[0] = 0x43     b[1] = 0x55 
    b[2] = 0x53     b[3] = 0x54 
    b[4] = 0x4F     b[5] = 0x4D 
    b[6] = 0x5F     b[7] = 0x44 
    b[8] = 0x45     b[9] = 0x46 
    b[10] = 0x45    b[11] = 0x41 
    b[12] = 0x54
end

function chamDefeatVoiceDefault()
    local b = ffi.cast("char*", 0x52AB44)
    b[0] = 0x4C     b[1] = 0x45 
    b[2] = 0x56     b[3] = 0x45 
    b[4] = 0x4C     b[5] = 0x5F 
    b[6] = 0x44     b[7] = 0x45 
    b[8] = 0x46     b[9] = 0x45 
    b[10] = 0x41    b[11] = 0x54 
    b[12] = 0
end

function chamStagingClaw()
    local b = ffi.cast("char*", 0x52AB30)
    b[0] = 0x43     b[1] = 0x55 
    b[2] = 0x53     b[3] = 0x54 
    b[4] = 0x4F     b[5] = 0x4D
    b[6] = 0x5F     b[7] = 0x53
    b[8] = 0x54     b[9] = 0x41
    b[10] = 0x47    b[11] = 0x49
    b[12] = 0x4E    b[13] = 0x47
    b[14] = 0x5F    b[15] = 0x43
    b[16] = 0x4C    b[17] = 0x41
    b[18] = 0x57 
end

function chamStagingClawDefault()
    local b = ffi.cast("char*", 0x52AB30)
    b[0] = 0x4C     b[1] = 0x45 
    b[2] = 0x56     b[3] = 0x45 
    b[4] = 0x4C     b[5] = 0x5F 
    b[6] = 0x53     b[7] = 0x54 
    b[8] = 0x41     b[9] = 0x47 
    b[10] = 0x49    b[11] = 0x4E 
    b[12] = 0x47    b[13] = 0x5F 
    b[14] = 0x43    b[15] = 0x4C 
    b[16] = 0x41    b[17] = 0x57 
    b[18] = 0
end

function chamStagingBoss()
    local b = ffi.cast("char*", 0x52AB1C)
    b[0] = 0x43     b[1] = 0x55 
    b[2] = 0x53     b[3] = 0x54 
    b[4] = 0x4F     b[5] = 0x4D
    b[6] = 0x5F     b[7] = 0x53
    b[8] = 0x54     b[9] = 0x41
    b[10] = 0x47    b[11] = 0x49
    b[12] = 0x4E    b[13] = 0x47
    b[14] = 0x5F    b[15] = 0x42
    b[16] = 0x4F    b[17] = 0x53
    b[18] = 0x53
end

function chamStagingBossDefault()
    local b = ffi.cast("char*", 0x52AB1C)
    b[0] = 0x4C     b[1] = 0x45 
    b[2] = 0x56     b[3] = 0x45 
    b[4] = 0x4C     b[5] = 0x5F 
    b[6] = 0x53     b[7] = 0x54 
    b[8] = 0x41     b[9] = 0x47 
    b[10] = 0x49    b[11] = 0x4E 
    b[12] = 0x47    b[13] = 0x5F 
    b[14] = 0x45    b[15] = 0x4E 
    b[16] = 0x45    b[17] = 0x4D 
    b[18] = 0x59
end

function main(self)
    BossStager(self)
	if self.State < 8004 then
	    chamBossname()
        chamDefeatVoice()
    else
        chamBossnameDefault()
        chamDefeatVoiceDefault()
    end
    if self.State > 8004 then
        chamStagingClaw()
        chamStagingBoss()
    else
        chamStagingClawDefault()
        chamStagingBossDefault()
    end
end
