local poisonDamage = 3
local poisonTime = 3000

function main(self)
        
    -- GetClaw()._field_F4 is a poison debuffs counter, set by logic PoisonHandler
    
    if self.State == 0 then
        self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
        self.timeDelay = 0
        self.visualCounter = CreateObject{x=GetClaw().X, y=GetClaw().Y-60, z=6000, logic="DoNothing", image="GAME_FONT"}
        self:SetImage("CUSTOM_BUBBLES")
        self:SetAnimation("GAME_CYCLE100")
        self.State = 1
    else
        self.X, self.Y = GetClaw().X, GetClaw().Y - 80
        self.visualCounter.X, self.visualCounter.Y = GetClaw().X, GetClaw().Y - 80
        if GetClaw()._field_F4 == 0 then
            self.DrawFlags.NoDraw = true
            self.visualCounter.DrawFlags.NoDraw = true
        elseif GetClaw().Health > 0 then
            self:AnimationStep()
            self.DrawFlags.NoDraw = false
            self.visualCounter.DrawFlags.NoDraw = false
            self.State = GetClaw()._field_F4 + 1
            self.visualCounter:SetFrame(26+self.State)
            if self.State == 11 then
                self.timeDelay = GetTime() + math.floor(poisonTime/2)
                PlaySound("CUSTOM_POISON1")
                GetClaw()._field_F4 = 9
            elseif self.State <= 10 then
                if GetTime() > self.timeDelay then
                    if GetClaw().Health > poisonDamage then
                        GetClaw().Health = GetClaw().Health - poisonDamage
                    elseif GetClaw().Health <= poisonDamage then
                        GetClaw().Health = 1
                    end
                    self.timeDelay = GetTime() + poisonTime
                    GetClaw()._field_F4 = GetClaw()._field_F4 - 1
                end
            end
        else
            GetClaw()._field_F4 = 0
        end
    end
end
